﻿<%@ PAGE EnableSessionState="True" title="" language="C#" masterpagefile="~/Site.master" autoeventwireup="true"
    inherits="ASLReports.EvalReports" codebehind="EvalReports.aspx.cs" %>
<%@ Register Assembly="Microsoft.ReportViewer.WebForms, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a"
    Namespace="Microsoft.Reporting.WebForms" TagPrefix="rsweb" %>
<ASP:CONTENT id="Content2" contentplaceholderid="MainContent" runat="Server">
    <script src="include/EvaluationCompletedd.js" type="text/javascript"></script>
    <script src="<%= Page.ResolveClientUrl("~/Scripts/treeFrame.js") %>" type="text/javascript"></script>
    <script src="<%= Page.ResolveClientUrl("~/Scripts/jquery/jquery-ui-1.8.18.custom.min.js") %>" type="text/javascript"></script>
    <script src="<%= Page.ResolveClientUrl("~/Scripts/jquery/jquery-ui-timepicker-addon.js") %>" type="text/javascript"></script>
    <script src="<%= Page.ResolveClientUrl("~/Scripts/jquery/jquery-ui-sliderAccess.js") %>" type="text/javascript"></script>
    <script src="<%= Page.ResolveClientUrl("~/Scripts/date.js") %>" type="text/javascript"></script>
    <script src="<%= Page.ResolveClientUrl("~/Scripts/popup.js") %>" type="text/javascript"></script>
    <script src="include/grid.locale-en.js" type="text/javascript"></script>
    <script src="include/jquery.jqGrid.min.js" type="text/javascript"></script>
    <script src="include/json2-min.js" type="text/javascript"></script>
    <style type="text/css">
        .myAltRowClass { background-color: #F8F8F8; background-image: none; }
    </style>
    <script language="javascript">
        $(document).ready(function () 
        {
            var today = Date.parse('today').toString('yyyy-MM-dd');
            var yesterday = new Date().add(-1).day();
            var firstDayOfMonth = Date.today().moveToFirstDayOfMonth().toString('yyyy-MM-dd');
            var lastDayOfMonth = Date.today().moveToLastDayOfMonth().toString('yyyy-MM-dd');
            var month = Date.parse('today').toString('MM');
            var year = Date.parse('today').toString('yyyy');
            var quarterMonth = (Math.floor(month / 3) * 3) + 1;
            var quarter = (Math.floor(month / 3)) + 1;
            var lastQuarter = (quarter > 1) ? quarter - 1 : lastQuarter = 4;
            var quarterStartDate = (quarterMonth < 10) ? year + '-0' + quarterMonth + '-01' : year + '-' + quarterMonth + '-01';
            var quarterEndDate = Date.parse(quarterStartDate).add(2).months().moveToLastDayOfMonth().toString('yyyy-MM-dd');
            var lastFullMonthStart = Date.today().add(-1).months().moveToFirstDayOfMonth().toString('yyyy-MM-dd');
            var lastFullMonthEnd = Date.today().add(-1).months().moveToLastDayOfMonth().toString('yyyy-MM-dd');
            var lastFullQuarterStart = ((((lastQuarter - 1) * 3) + 1) < 10) ? year + '-0' + (((lastQuarter - 1) * 3) + 1) + '-01' : year + '-' + (((lastQuarter - 1) * 3) + 1) + '-01';
            var lastFullQuarterEnd = Date.parse(lastFullQuarterStart).add(2).months().moveToLastDayOfMonth().toString('yyyy-MM-dd');
            var lastFullYearStart = Date.today().add(-1).years().toString('yyyy') + '-01-01';
            var lastFullYearEnd = Date.today().add(-1).years().toString('yyyy') + '-12-31';
            var currentFullYearStart = Date.parse('today').toString('yyyy') + '-01-01';
            var currentFullWeekStart = Date.monday().toString('yyyy-MM-dd');
            var currentFullWeekEnd = Date.today().moveToDayOfWeek(0);
            var lastFullWeekStart;
            var lastFullWeekEnd;
            if (Date.today().is().monday()) {
                lastFullWeekStart = Date.today().last().monday().toString('yyyy-MM-dd');
                lastFullWeekEnd = Date.today().last().monday().add(+6).days().toString('yyyy-MM-dd');
            }
            else {
                lastFullWeekStart = Date.today().last().monday().add(-7).days().toString('yyyy-MM-dd');
                lastFullWeekEnd = Date.today().last().monday().add(-1).days().toString('yyyy-MM-dd');
            }
            
            $("#<%=txtDateStart.ClientID %>").datepicker(
            {
                dateFormat: 'yy-mm-dd',
                onClose: function (dateText, inst) {
                    var endDateTextBox = $("#<%= txtDateEnd.ClientID %>");
                    if (endDateTextBox.val() != '') {
                        var testStartDate = new Date(dateText);
                        var testEndDate = new Date(endDateTextBox.val());
                        if (testStartDate > testEndDate)
                            endDateTextBox.val(dateText);
                    }
                    else {
                        endDateTextBox.val(dateText);
                    }
                },
                onSelect: function (selectedDateTime) {
                    var start = $(this).datepicker('getDate');
                    $("#<%= txtDateEnd.ClientID %>").datepicker('option', 'minDate', new Date(start.getTime()));
                }
            });
            $("#<%= txtDateEnd.ClientID %>").datepicker(
            {
                dateFormat: 'yy-mm-dd',
                onClose: function (dateText, inst) {
                    var startDateTextBox = $("#<%=txtDateStart.ClientID %>");
                    if (startDateTextBox.val() != '') {
                        var testStartDate = new Date(startDateTextBox.val());
                        var testEndDate = new Date(dateText);
                        if (testStartDate > testEndDate)
                            startDateTextBox.val(dateText);
                    }
                    else {
                        startDateTextBox.val(dateText);
                    }
                },
                onSelect: function (selectedDateTime) {
                    var end = $(this).datepicker('getDate');
                    $("#<%=txtDateStart.ClientID %>").datepicker('option', 'maxDate', new Date(end.getTime()));
                }
                , beforeShow: function () {
                    var d = $("#<%=txtDateStart.ClientID %>").datepicker('getDate');
                    if (d) return { minDate: d }
                }
            });

            $("#<%=txtDateStart.ClientID %>").attr('readOnly', 'true');
            $("#<%= txtDateEnd.ClientID %>").attr('readOnly', 'true');
            if ($("#<%= txtDateEnd.ClientID %>").val() == '')
                $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', new Date());
            if ($("#<%=txtDateStart.ClientID %>").val() == '')
                $("#<%=txtDateStart.ClientID %>").datepicker("setDate", -30);
            
            $("#<%= ShortDateSelect.ClientID %>").change(function () {
                switch (this.value) {
                    case '0':
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', new Date());
                        $("#<%=txtDateStart.ClientID %>").datepicker("setDate", -7);
                        break;
                    case '1': //Today
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', today);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', today);
                        break;
                    case '2': //Yesterday
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', yesterday);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', yesterday);
                        break;
                    case '3': //This week
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', currentFullWeekStart);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', currentFullWeekEnd);
                        break;
                    case '4': //Last week
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', lastFullWeekStart);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', lastFullWeekEnd);
                        break;
                    case '5': //This month
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', firstDayOfMonth);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', lastDayOfMonth);
                        break;
                    case '6': //Last month
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', lastFullMonthStart);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', lastFullMonthEnd);
                        break;
                    case '7': //This Quarter
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', quarterStartDate);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', quarterEndDate);
                        break;
                    case '8': //Last Quarter
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', lastFullQuarterStart);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', lastFullQuarterEnd);
                        break;
                    case '9': //Year to date
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', currentFullYearStart);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', today);
                        break;
                    case '10': //Last Year
                        $("#<%=txtDateStart.ClientID %>").datepicker('setDate', lastFullYearStart);
                        $("#<%= txtDateEnd.ClientID %>").datepicker('setDate', lastFullYearEnd);
                        break;
                    default:
                        alert("ERROR! Select Executive Summary");
                        break;
                }
            });
            //------------------------Load Survey list in dropdown list-----------------------------------------------------
            $.ajax({ type: "POST",
                url: "PageFunctions.aspx/GetSurveyListDropDownList",
                contentType: "application/json; charset=utf-8",
                data: {},  // For empty input data use "{}",
                serializeGridData: function (postData) {
                    return JSON.stringify(postData);
                },
                dataType: "json",
                success: LoadSurveyDropdownList,
                error: FailedSurvey
            });
            $("input[name='EvalType'][value='" + $('#<%= EvaluationType.ClientID%>').val() + "']").attr("checked", true);

            LoadSettings();

            var prm = Sys.WebForms.PageRequestManager.getInstance();
            prm.add_endRequest(EndRequestHandler);
            $("#<%= btnView.ClientID %>").click(function () {
                $("#blocker").show();
            });

        });
        function EndRequestHandler(sender, args) {
            LoadSettings();
        }
    function LoadSurveyDropdownList(results) {
        try {
            var obj = $.parseJSON(results.d);
            var option = '';
            $.each(obj, function () {
                if ($('#<%= selectedForm.ClientID%>').val() == this["ID"])
                    option += '<option value="' + this["ID"] + '" selected>' + this["Title"] + '</option>';
                else
                    option += '<option value="' + this["ID"] + '">' + this["Title"] + '</option>';
                
            });
            $('#QAList').append(option);

        } catch (e) {
            alert("LoadSurvey List JSON parsing Error.");
        }
    }

    function FailedSurvey(result) {
        alert(result.status + ' ' + result.statusText);
    }

    function TreeLogicforSQLOptions() {
        var SQL = '';
        var oldCheckBoxStatusVal = '';
        var elements = document.getElementById("<%= UsersTree.ClientID %>").getElementsByTagName('input');
        for (var i = 0; i < elements.length; i++) {
            if (elements.item(i).type == "checkbox") {
                if (elements.item(i).checked) {
                    var NodeValue = elements.item(i).nextSibling;
                    var ValuesofNode = NodeValue.nameProp.split("\\");
                    ValuesofNode = $(ValuesofNode).last()[0];
                    ValuesofNode = ValuesofNode.slice(0, -2);
                    var param = ValuesofNode.split(":");
                    var param1 = param[0];
                    var param2 = param[1];
                    var isGroup = param[2];
                    if (isGroup.toString() == "0" || g_UserType == 0) {
                        var Parent = GetParentByTagName123("div", elements.item(i)).previousSibling;
                        var ParentCheckBox = Parent.getElementsByTagName("input")[0];
                        if (ParentCheckBox != null) {
                            if (param2 != "") {
                                if (ParentCheckBox.checked && g_UserType == 0) {
                                    if (SQL == '') {
                                        SQL = SQL + " (";
                                    }
                                    else {
                                        SQL = SQL + " or ";
                                    }
                                    
                                    SQL = SQL + "(CI.GroupNum=" + param1 + " AND CI.UserNum=" + param2 + ")";
                                }
                                else {
                                    if (SQL == '') {
                                        SQL = SQL + " (";
                                    }
                                    else {
                                        SQL = SQL + " or ";
                                    }
                                    SQL = SQL + "(CI.GroupNum=" + param1 + " AND CI.UserNum=" + param2 + ")";
                                }
                            }
                        }
                    }
                    else {

                        if (g_UserType == 1) {
                            if ($(elements.item(i)).next().html() == 'Parent') {
                                break;
                            }
                            else {

                                if (SQL == '') {
                                    SQL = SQL + " (";
                                }
                                else {
                                    SQL = SQL + " or ";
                                }
                                SQL = SQL + "(CI.GroupNum IN (" + param1 + "))";
                                oldCheckBoxStatusVal = param1;
                            }
                        }
                    }
                }
            }
        }
        if (SQL != "")
            SQL = SQL + " )";
        return SQL;
    }

    function ValidateNumber(e) {
        if (e.which < 48 || e.which > 59) {
            e.preventDefault();
        }
    }

    function ValidateVals() {
        if ($('#QAList').val() == 0) {
            alert("Please select Evaluation Form.");
            return false;
        }
        
        $('#<%= selectedForm.ClientID%>').val($('#QAList').val());
        $('#<%= txtQAForm.ClientID%>').val($("#QAList option:selected").text());
        $('#<%= EvaluationType.ClientID%>').val($('input[name=EvalType]:radio:checked').val());
        var users = TreeLogicforSQLOptions();
        if (g_UserType == 0 && users== "") {
            alert("Please select users.");
            return false;
        }
        if (users.length > 0)
            $('#<%= OptionString.ClientID%>').val(' AND ' + users);
        else
            $('#<%= OptionString.ClientID%>').val('');
        return true;
    }

    function LoadSettings() {
        HideAutoLogin();
        document.getElementById("IDtblMaster").style.width = $(window).width() - 4 + 'px';
        document.getElementById("IDtblMaster").style.height = $(window).height() - 100 + 'px';
        $("#LeftTree").height($("#IDtblMaster").height() - $("#tblSearchPanelID").height() - 10 + 'px');

        $("#<%= divExcel.ClientID %>").height(($("#IDtrParent").height() - 20) + 'px');
        $("#<%= divExcel.ClientID %>").width(($("#IDtblMaster").width() - 250) + 'px');

        $("#<%= IDGridReportViewer.ClientID %>").width($("#<%= divExcel.ClientID %>").width() + 'px');
        $("#<%= IDGridReportViewer.ClientID %>").height($("#<%= divExcel.ClientID %>").height() + 'px');
        $("#<%= IDDivMsg.ClientID %>").width(($("#IDtblMaster").width() - 250) + 'px');
         
    }
    </script>
    <div id="blocker" style="display:none">
        <div style="width: 80px; height: 60px;padding-left: 15px; padding-top: 15px; background-color:#ECE9D8; border:1px solid black;filter: alpha(opacity = 90);opacity:.90;"><img src="Images/Loader.gif" alt="Please wait while Loading..."/><br/><span style="font-family:Calibri;font-size:14pt;">Loading...</span></div>
    </div>
    <asp:HiddenField id="selectedForm" value="0" runat="server"/>
    <asp:HiddenField id="EvaluationType" value="-1" runat="server"/>
    <asp:HiddenField ID="txtQAForm" runat="server"/>
    <asp:HiddenField ID="OptionString" runat="server"/>

    <table class="main" cellpadding="0" cellspacing="0" border="0" id="table1" style="height: 100%; width: 100%;background-color: #F8F8F8;">
        <tr id="IDtrParent">
            <td class="leftCol" valign="top" id="tdLeftPanel" style="background: #A1D8F1; height:100%; width: 250px;">
                <ASP:UPDATEPANEL runat="server" id="upd1" updatemode="Always" rendermode="Block">
                    <CONTENTTEMPLATE>
                        <table style="width: 100%" id="UserTreeTDID">
                            <tr>
                                <td style="width: 100%; background-color: #D5EBF6; vertical-align:top;">
                                    <div style="width: 100%; height: 200px; float: left; overflow: auto;" id="LeftTree">
                                        <ASP:TREEVIEW id="UsersTree" runat="server" showlines="true" showcheckboxes="All" cssclass="TreeViewLinkdesign">
                                        </ASP:TREEVIEW>
                                    </div>
                                </td>
                            </tr>
                        </table>
                    </CONTENTTEMPLATE>
                </ASP:UPDATEPANEL>
                <table style="padding-top: 3px;" id="tblSearchPanelID">
                        <tr>
                            <td class="SearchCSS" style="font-weight: bold;padding-bottom: 3px;">Report Type:</td>
                            <td colspan="2">
                                <ASP:DROPDOWNLIST id="ReportType" runat="server" cssclass="DropDown4Search">
                                    <ASP:LISTITEM value="1" Text="Tabular Report"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="2" Text="Bar Chart"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="3" Text="Stacked Bar Chart"></ASP:LISTITEM>
                                </ASP:DROPDOWNLIST>
                            </td>
                        </tr>
                        <tr>
                            <td class="SearchCSS" style="font-weight: bold;padding-bottom: 3px;">Report By:</td>
                            <td colspan="2" style="padding-top: 3px;">
                                <ASP:DROPDOWNLIST id="ReportBy" runat="server" cssclass="DropDown4Search">
                                    <ASP:LISTITEM value="1" text="Agents"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="2" text="Groups"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="3" text="Evaluators"></ASP:LISTITEM>
                                </ASP:DROPDOWNLIST>
                            </td>
                        </tr>
                        <tr>
                            <td class="SearchCSS" style="font-weight: bold;">QA Form:</td>
                            <td colspan="2" style="padding-top: 3px;">
                                <select id="QAList" class="DropDown4Search">
                                    <!--option value="0">Select Evaluation Form</option-->
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td class="SearchCSS" style="font-weight: bold;">Date Shortcut:</td>
                            <td colspan="2" style="padding-top: 3px;">
                                <ASP:DROPDOWNLIST id="ShortDateSelect" runat="server" cssclass="DropDown4Search">
                                    <ASP:LISTITEM value="1" text="Quick Date selection"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="1" text="Today"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="2" text="Yesterday"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="3" text="This week"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="4" text="Last week"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="5" text="This month"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="6" text="Last month"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="7" text="This Quarter"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="8" text="Last Quarter"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="9" text="Year to date"></ASP:LISTITEM>
                                    <ASP:LISTITEM value="10" text="Last Year"></ASP:LISTITEM>
                                </ASP:DROPDOWNLIST>
                            </td>
                        </tr>
                        <tr style="padding-top: 3px; padding-bottom: 3px;">
                            <td class="SearchCSS" style="font-weight: bold;">Date:</td>
                            <td colspan="2">
                                <asp:TextBox id="txtDateStart" class="textEntryDate" placeholder="FROM" runat="server"/>
                                <asp:TextBox type="text" id="txtDateEnd" class="textEntryDate" placeholder="TO" runat="server"/>
                            </td>
                        </tr>                        
                        <tr style="padding-top: 3px;">
                            <td class="SearchCSS" nowrap="nowrap" style="font-weight: bold;">Score:</td>
                            <td colspan="2">
                                <asp:TextBox type="text" id="MinScore" class="textEntryDate" placeholder="Min. Score" onkeypress="return ValidateNumber(event)" runat="server"/>
                                <asp:TextBox type="text" id="MaxScore" class="textEntryDate" placeholder="Max. Score" onkeypress="return ValidateNumber(event)" runat="server"/>
                            </td>
                        </tr>
                        <tr>
                            <td class="SearchCSS" style="font-weight: bold;">Evaluations:</td>
                            <td colspan="2">
                                <div id="EvalationType">
                                    <label><input type="radio" value="-1" name="EvalType"  id="EvalType" checked="checked"><span>ALL</span></label>
                                    <label><input type="radio" value="1"  name="EvalType"  id="EvalType"><span>SHARED</span></label>
                                    <label><input type="radio" value="0"  name="EvalType"  id="EvalType"><span>UNSHARED</span></label>
                                </div>
                            </td>
                        </tr>
                        <tr style="padding-top: 10px;">
                            <td colspan="3" style="padding-left: 60px;">
                            <asp:Button ID="btnView" Text="Report" CssClass="submitButton" runat="server" OnClientClick="return ValidateVals();" OnClick="btnView_Click" /></td>
                        </tr>
                    </table>
            </td>
            <td id="IDTDRightPan" style="vertical-align:top;border: solid 1px #7f9db9; background: White; height:100px;">
                <div id="IDDivMsg" runat="server" clientidmode="Static" visible="false">
                    <span class="red">
                        <asp:Label ID="lblInfo" runat="server" Text="No Data to Display" />
                    </span>
                </div>
                <div id="divExcel" runat="server" clientidmode="Static" style="float:left; margin-left:0px; padding:3px;"> 
                    <rsweb:ReportViewer ID="IDGridReportViewer" Height="100%" Width="100%" runat="server" Font-Names="Calibri" Font-Size="8pt" InteractiveDeviceInfos="(Collection)"
                        WaitMessageFont-Names="Calibri" WaitMessageFont-Size="14pt">
                        <ServerReport ReportServerUrl="" />
                        <LocalReport ReportPath="">
                        </LocalReport>
                    </rsweb:ReportViewer>
                </div>
        </td>
        </tr>
    </table>
</ASP:CONTENT>