﻿/// <reference path="jquery-1.3.2.js" />
var GloabParams = new Object();
var g_MenuCreated = 0;
var g_UserType = 0;
var g_FirstTime = 0;
var g_SaveCall = 0;

function getColumnSrcIndexByName (grid, columnName) {
    var cm = $("#list")[0].p.colNames,
        i = 0, index = 0, l = cm.length;
    while (i < l) {
        if (cm[i] == columnName) {
            return index;
        } else if (cm[i] !== 'rn' && cm[i] !== 'cb' && cm[i] !== 'subgrid') {
            index++;
        }
        i++;
    }
    return -1;
}

function SubmitComments() {
    var params = new Object();
    var textComments = document.getElementById("txtComments").value;
    textComments = textComments.replace(/[^a-z0-9\s]/gi, '').replace(/[_\s]/g, ' ');
    params.Comments = textComments;
    params.CallID = document.getElementById("MYUpDateCallID").value;
    $.ajax({
        url: "PageFunctions.aspx/ManageComments",
        data: JSON.stringify(params),  // For empty input data use "{}",
        dataType: "json",
        type: "POST",
        serializeGridData: function(postData) {
            return JSON.stringify(postData);
        },
        contentType: "application/json; charset=utf-8",
        success: function(result) {
            jQuery("#list").setCell(GloabParams.rowid.toString(), getColumnSrcIndexByName($("#list"), 'Call Comment'), params.Comments, '', '');
            $("#UpdateCallStatusPopup").dialog('close');
            //alert(result.d);
        },
        error: function(result) { alert(result.statusText); }
    });
}

function showPopUpMen() {
    $("#UpdateCallStatusPopup").dialog({
        width: '340px',
        title: 'Add/Update Call Comments',
        modal: true,
        open: function() {
            $(this).parent().appendTo();
        }
    });
}

var OnClick = function(Sender, EventArgs) {
    switch (EventArgs.CommandName) {
    case 'Normal':
        GloabParams.Flag = '0';
        $.ajax({
            url: "PageFunctions.aspx/UpdateCallStatus",
            data: JSON.stringify(GloabParams),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: function(result) {
                var ID = "img002" + GloabParams.rowid.toString();
                document.getElementById(ID).src = 'images/empty.gif';
                document.getElementById(ID).title = "Normal Call";
            },
            error: CallStatusFailure
        });
        break;
    case 'Critical':
        GloabParams.Flag = '1';
        $.ajax({
            url: "PageFunctions.aspx/UpdateCallStatus",
            data: JSON.stringify(GloabParams),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: function(result) {
                var ID = "img002" + GloabParams.rowid.toString();
                document.getElementById(ID).src = "images/critical.gif";
                document.getElementById(ID).title = "Critical Call";
            },
            error: CallStatusFailure
        });
        break;
    case 'important':
        GloabParams.Flag = '2';
        $.ajax({
            url: "PageFunctions.aspx/UpdateCallStatus",
            data: JSON.stringify(GloabParams),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: function(result) {
                var ID = "img002" + GloabParams.rowid.toString();
                document.getElementById(ID).src = "images/important.gif";
                document.getElementById(ID).title = "Important Call";

            },
            error: CallStatusFailure
        });
        break;
    case 'Delete':
        GloabParams.Flag = '0';
        var _RetainValueIDX = 'Yes';
        var RowData = jQuery("#list").getRowData(GloabParams.rowid);
        RetainValueIDX = RowData['RetainValueIDX'];
        if (RetainValueIDX == 'Yes') {
            _RetainValueIDX = 'No';
            GloabParams.Flag = '1';
        } else {
            _RetainValueIDX = 'Yes';
            GloabParams.Flag = '0';
        }
        $.ajax({
            url: "PageFunctions.aspx/DeverDeleteCall",
            data: JSON.stringify(GloabParams),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: function(result) {
                jQuery("#list").setCell(GloabParams.rowid.toString(), getColumnSrcIndexByName($("#list"), 'Delete?'), GloabParams.Flag, '', '');
            },
            error: CallStatusFailure
        });
        break;
    case 'Comments':
        var RowData = jQuery("#list").getRowData(GloabParams.rowid);
        comments = RowData['CallCommentIDX'];
        document.getElementById("MYUpDateCallID").value = "";
        document.getElementById("txtComments").value = "";
        document.getElementById("txtComments").value = comments;
        document.getElementById("MYUpDateCallID").value = GloabParams.CallIDIDX;
        showPopUpMen();
        break;
    case 'Evaluation':
        var RowData = jQuery("#list").getRowData(GloabParams.rowid);
        document.getElementById("EvalCallID").value = GloabParams.CallIDIDX;
        AddCalltoEvaluationDlg();
        break;
    case 'Cancel':
        oCustomContextMenu.Hide();
        break;
    case 'RatingLevel1':
        SaveRating(GloabParams.CallIDIDX, 1);
        break;
    case 'RatingLevel2':
        SaveRating(GloabParams.CallIDIDX, 2);
        break;
    case 'RatingLevel3':
        SaveRating(GloabParams.CallIDIDX, 3);
        break;
    case 'RatingLevel4':
        SaveRating(GloabParams.CallIDIDX, 4);
        break;
    case 'RatingLevel5':
        SaveRating(GloabParams.CallIDIDX, 5);
        break;
    }
    oCustomContextMenu.Hide();
}

function CallStatusSuccess(result) {
    alert(result.d);
}

function CallStatusFailure(result) {
    alert(result.statusText);

}

function successFunction(jsondata) {
    $("#blocker").show();
    ASPlayer_Clear();
    var thegrid = jQuery("#list")[0];
    thegrid.addJSONData(JSON.parse(jsondata.d));
    $("#blocker").hide();
}

function ASPlayer_Clear() {
    var ASPlayer = document.getElementById("ASPlayer");
    if (!ASPlayer) {
        alert("Player is not loaded.");
        return;
    }
    try {
        ASPlayer.Stop();
        ASPlayer.ClearPlayList();
        CurrentPlayerState = false;
        LastPlayedCallID = null;
    } catch(e) {
        alert("Unknown error on clearing play list.");
        return;
    }
}

function ErrorFunction(result) { //alert(result.statusText);
    $("#blocker").show();
    alert("No Record Found");
    $("#blocker").hide();
}

function getImage(cell, options, row) {
    var PlayStatus = 'img001' + row[1];
    var calStatus = 'img002' + row[1];
    var calEval = 'img003' + row[1];
    var rowdata = "";
    
    rowdata = rowdata + "<img src='images/default.gif' valign='middle'  align='left' title='double click to play the call'  id='" + PlayStatus + "'/>";
    
    if (parseInt(row[2]) == 0)
        rowdata = rowdata + "<img src='images/empty.gif' valign='middle' align='center' title = 'Normal call' id='" + calStatus + "'/>";
    else if (parseInt(row[2]) == 1)
        rowdata = rowdata + "<img src='images/critical.gif' valign='middle' align='center' title = 'critical call' id='" + calStatus + "'/>";
    else if (parseInt(row[2]) == 2)
        rowdata = rowdata + "<img src='images/important.gif' valign='middle' align='center' title = 'important call'  id='" + calStatus + "'/>";
    
    if (row[35] == 1)
		rowdata = rowdata + "&nbsp;<img src='images/evaluation.png' valign='middle' align='center' title = 'Call added to evaluations'  id='" + calEval + "'/>";
    else
        rowdata = rowdata + "&nbsp;<img src='images/empty.gif' valign='middle' align='center' id='" + calEval + "'/>";
    
    return (rowdata);
}

function SetCallDriction(cell, options, row) {
    var rowdata = "";
    if (parseInt(row[12]) == 3) {
        rowdata = rowdata + "<img src='images/unknown.gif' align='right' title = 'Unknown direction'/>";
    }else if (parseInt(row[12]) == 1) {
        rowdata = rowdata + "<img src='images/incoming.gif' align='center' title = 'incoming call'/>";
    } else if (parseInt(row[12]) == 2) {
        rowdata = rowdata + "<img src='images/outgoing.gif' align='center' title = 'outgoing call'/>";
    }
    return (rowdata);
}

function GetDelStatus(cell, options, row) {
    var rowdata = "";
    if (cell == 0) {
        rowdata = rowdata + "Yes";
    } else if (cell == 1) {
        rowdata = rowdata + "No";
    }
    return (rowdata);
}

function dataBindToGrid() {
    jQuery("#list").jqGrid(
        {
            datatype: function (pdata) { getProducts(pdata); },
            colNames: ['', '', 'CallStatusFlagIDX', 'LODFlagIDX', 'BookMarkFlagIDX', 'Call ID', 'Agent Name', 'Group', 'Extension', 'Ext Name', 'Call Start Time', 'Duration', '', 'From', 'To', 'Rating', 'Call Tag', 'Bookmarks', 'Call Comment', 'ROD Cust Name ', 'ROD Cust Num', 'ROD Cust Info 2', 'ANI Name', 'ANI Phone', 'ANI Detail', 'StartDayIDX', 'StartTimeIDX', 'RecorderIPIDX', 'InHDDIDX', 'CallIndexIDX', 'BackupIDIDX', 'AudioFileNameIDX', 'VideoFileNameIDX', 'Delete?', 'PlayServerPortIDX', 'EvalStatusIDX'],
            colModel: [{ name: 'PlayList', index: '', width: 60, align: 'center', editable: true, formatter: getImage },
                { name: 'Index', index: 'idx', width: 40, align: 'center', key: true, hidden: true },
                { name: 'CallStatusFlagIDX', index: 'CallStatusFlagIDX', width: 60, align: 'left', hidden: true },
                { name: 'LODFlagIDX', index: 'LODFlagIDX', width: 60, align: 'left', hidden: true },
                { name: 'BookMarkFlagIDX', index: 'BookMarkFlagIDX', width: 60, align: 'left', hidden: true },
                { name: 'CallIDIDX', index: 'CallIDIDX', width: 250, align: 'left', hidden: true },
                { name: 'UserNameIDX', index: 'UserNameIDX', width: 90, align: 'left' },
                { name: 'GroupNameIDX', index: 'GroupNameIDX', width: 60, align: 'left', hidden: false },
                { name: 'ExtIDX', index: 'ExtIDX', width: 60, align: 'center' },
                { name: 'ExtNameIDX', index: 'ExtNameIDX', width: 100, align: 'left', hidden: true },
                { name: 'CallTimeIDX', index: 'CallTimeIDX', width: 120, align: 'left' },
                { name: 'CallDurationIDX', index: 'CallDurationIDX', width: 60, align: 'center' },
                { name: 'DirectionIDX', index: 'DirectionIDX', width: 16, align: 'center', editable: true, formatter: SetCallDriction },
                { name: 'CallerIDX', index: 'CallerIDX', width: 110, align: 'left', hidden: false },
                { name: 'CalledIDX', index: 'CalledIDX', width: 110, align: 'left', hidden: false },
                { name: 'CallRating', index: 'CallRating', width: 70, align: 'center', hidden: false },
                { name: 'CallTagIDX', index: 'CallTagIDX', width: 100, align: 'left', hidden: false },
                { name: 'BookmarksIDX', index: 'BookmarksIDX', width: 200, align: 'left' },
                { name: 'CallCommentIDX', index: 'CallCommentIDX', width: 200, align: 'left', editable: true },
                { name: 'ROD_CustNameIDX', index: 'ROD_CustNameIDX', width: 100, align: 'left', hidden: true },
                { name: 'ROD_CustNumIDX', index: 'ROD_CustNumIDX', width: 100, align: 'left', hidden: true },
                { name: 'ROD_CustInfo2IDX', index: 'ROD_CustInfo2IDX', width: 100, align: 'left', hidden: true },
                { name: 'ANI_NAMEIDX', index: 'ANI_NAMEIDX', width: 150, align: 'left' },
                { name: 'ANI_PHIDX', index: 'ANI_PHIDX', width: 150, align: 'left' },
                { name: 'ANI_DETAILSIDX', index: 'ANI_DETAILSIDX', width: 150, align: 'left' },
                { name: 'StartDayIDX', index: 'StartDayIDX', width: 150, align: 'left', hidden: true },
                { name: 'StartTimeIDX', index: 'StartTimeIDX', width: 150, align: 'left', hidden: true },
                { name: 'RecorderIPIDX', index: 'RecorderIPIDX', width: 150, align: 'left', hidden: true },
                { name: 'InHDDIDX', index: 'InHDDIDX', width: 150, align: 'left', hidden: true },
                { name: 'CallIndexIDX', index: 'CallIndexIDX', width: 150, align: 'left', hidden: true },
                { name: 'BackupIDIDX', index: 'BackupIDIDX', width: 150, align: 'left', hidden: true },
                { name: 'AudioFileNameIDX', index: 'AudioFileNameIDX', width: 150, align: 'left', hidden: true },
                { name: 'VideoFileNameIDX', index: 'VideoFileNameIDX', width: 150, align: 'left', hidden: true },
                { name: 'RetainValueIDX', index: 'RetainValueIDX', width: 50, align: 'center', editable: true, formatter: GetDelStatus },
                { name: 'PlayServerPortIDX', index: 'PlayServerPortIDX', width: 100, align: 'left', hidden: true },
                { name: 'EvalStatusIDX', index: 'EvalStatusIDX', width: 120, align: 'left', hidden: true }
            ],
            loadonce: false,
            paging: true,
            rowNum: $('#ctl00_MainContent_txtRowCount').val(),
            viewrecords: true,
            mtype: "POST",
            sortable: true,
            pager: '#pager',
            reloadAfterSubmit: false,
            sortname: 'idx',
            gridview: true,
            sortorder: "asc",
            height: $("#tdGrid").height() - 61,
            width: $("#tdGrid").width(),
            shrinkToFit: false,
            multiselect: true,
            rownumbers: true,
            altRows: true,
            resize: true,
            altclass: 'myAltRowClass',
            ondblClickRow: function (rowid) {
                var RowData = jQuery("#list").getRowData(rowid);
                RowIndex = RowData['Index'];
                RecorderIPIDX = RowData['RecorderIPIDX'];
                UserNameIDX = RowData['UserNameIDX'];
                StartTimeIDX = RowData['StartTimeIDX'];
                AudioFileNameIDX = RowData['AudioFileNameIDX'];
                VideoFileNameIDX = RowData['VideoFileNameIDX'];
                CallDurationIDX = RowData['CallDurationIDX'];
                ExtIDX = RowData['ExtIDX'];
                CallTimeIDX = RowData['CallTimeIDX'];
                RecorderIPIDX = RowData['RecorderIPIDX'];
                ExtNameIDX = RowData['ExtNameIDX'];
                PlayServerPortIDX = RowData['PlayServerPortIDX'];
                StartDayIDX = RowData['StartDayIDX'];
                CallIndexIDX = RowData['CallIndexIDX'];
                var ASPlayer = document.getElementById("ASPlayer");

                try {
                    if (IsAlreadyAdded(RowIndex) == false) {
                        ASPlayer.AddToPlayList(RowIndex, RecorderIPIDX, PlayServerPortIDX, "-", 0, StartDayIDX, GetDurationMili(CallTimeIDX.substring(11, 19)), AudioFileNameIDX, VideoFileNameIDX, CallDurationIDX, ExtIDX, CallTimeIDX, 1, 1, "");
                    }
                    setTimeout("DBCLICKeVENT('" + RowIndex + "')", 200);
                } catch (e) {
                }
            },

            onRightClickRow: function (rowid, iRow, iCol, e) {
                var RowData = jQuery("#list").getRowData(rowid);
                CallIDIDX = RowData["CallIDIDX"];
                GloabParams.CallIDIDX = CallIDIDX;
                GloabParams.iRow = iRow;
                GloabParams.iCol = iCol;
                GloabParams.rowid = rowid;
                if (g_MenuCreated == 0) {
                    CreatePopupMenu();
                }
                oCustomContextMenu.Display(e);
            },
            onSelectAll: function (rowIDs, status) {
                if (status == true) {
                    for (i = 0; i < rowIDs.length; i++) {
                        var RowData = jQuery("#list").getRowData(rowIDs[i]);
                        RowIndex = RowData['Index'];
                        RecorderIPIDX = RowData['RecorderIPIDX'];
                        UserNameIDX = RowData['UserNameIDX'];
                        StartTimeIDX = RowData['StartTimeIDX'];
                        AudioFileNameIDX = RowData['AudioFileNameIDX'];
                        VideoFileNameIDX = RowData['VideoFileNameIDX'];
                        CallDurationIDX = RowData['CallDurationIDX'];
                        ExtIDX = RowData['ExtIDX'];
                        CallTimeIDX = RowData['CallTimeIDX'];
                        RecorderIPIDX = RowData['RecorderIPIDX'];
                        ExtNameIDX = RowData['ExtNameIDX'];
                        PlayServerPortIDX = RowData['PlayServerPortIDX'];

                        StartDayIDX = RowData['StartDayIDX'];
                        CallIndexIDX = RowData['CallIndexIDX'];
                        var ASPlayer = document.getElementById("ASPlayer");

                        try {
                            if (IsAlreadyAdded(RowIndex) == false) {
                                ASPlayer.AddToPlayList(RowIndex, RecorderIPIDX, PlayServerPortIDX, "-", 0, StartDayIDX, GetDurationMili(CallTimeIDX.substring(11, 19)), AudioFileNameIDX, VideoFileNameIDX, CallDurationIDX, ExtIDX, CallTimeIDX, 1, 1, "");
                            }
                        } catch (e) {
                        }
                    }
                } else {
                    var ASPlayer = document.getElementById("ASPlayer");
                    try {
                        ASPlayer.Stop();
                    } catch (e) {
                    }
                    for (i = 0; i < rowIDs.length; i++) {
                        var RowData = jQuery("#list").getRowData(rowIDs[i]);
                        RowIndex = RowData['Index'];
                        try {
                            ASPlayer.RemovePlayList(RowIndex);
                        } catch (e) {
                        }
                    }
                }
            },

            onSelectRow: function (rowid, status) {
                var RowData = jQuery("#list").getRowData(rowid);
                RowIndex = RowData['Index'];
                RecorderIPIDX = RowData['RecorderIPIDX'];
                UserNameIDX = RowData['UserNameIDX'];
                StartTimeIDX = RowData['StartTimeIDX'];
                AudioFileNameIDX = RowData['AudioFileNameIDX'];
                VideoFileNameIDX = RowData['VideoFileNameIDX'];
                CallDurationIDX = RowData['CallDurationIDX'];
                ExtIDX = RowData['ExtIDX'];
                CallTimeIDX = RowData['CallTimeIDX'];
                RecorderIPIDX = RowData['RecorderIPIDX'];
                ExtNameIDX = RowData['ExtNameIDX'];
                PlayServerPortIDX = RowData['PlayServerPortIDX'];

                StartDayIDX = RowData['StartDayIDX'];
                CallIndexIDX = RowData['CallIndexIDX'];
                var ASPlayer = document.getElementById("ASPlayer");
                if (status == true) {
                    try {
                        if (IsAlreadyAdded(RowIndex) == false) {
                            ASPlayer.AddToPlayList(RowIndex, RecorderIPIDX, PlayServerPortIDX, "-", 0, StartDayIDX, GetDurationMili(CallTimeIDX.substring(11, 19)), AudioFileNameIDX, VideoFileNameIDX, CallDurationIDX, ExtIDX, CallTimeIDX, 1, 1, "");
                        }
                    } catch (e) {
                    }
                } else {
                    var ID = "img001" + RowData["Index"].toString();
                    if (document.getElementById(ID).src.lastIndexOf('play.gif') > 0 || document.getElementById(ID).src.lastIndexOf('pause.gif') > 0) {
                        if (IsAlreadyAdded(RowIndex) == false)
                            ASPlayer.AddToPlayList(RowIndex, RecorderIPIDX, PlayServerPortIDX, "-", 0, StartDayIDX, GetDurationMili(CallTimeIDX.substring(11, 19)), AudioFileNameIDX, VideoFileNameIDX, CallDurationIDX, ExtIDX, CallTimeIDX, 1, 1, "");
                        if (!$('#' + rowid + ' input[type=checkbox]').prop('checked'))
                            $("#list").setSelection(rowid, true);
                        return true;
                    }
                    RowIndex = RowData['Index'];
                    var ASPlayer = document.getElementById("ASPlayer");
                    try {
                        ASPlayer.RemovePlayList(RowIndex);
                    } catch (e) {
                    }
                }
            }
        });
    $('#list').mouseover(function(e) {
        if ($("#showGridpopup").prop('checked') || $("#showGridPopupHidden").prop('checked')) {
            var moveDown = 0;
            var horizontalPos = 0;
            var verticalPos = 0;
            var showData = "";
            var $td = $(e.target).closest('td'), $tr = $td.closest('tr.jqgrow'),
                rowId = $tr.attr('id');
            var RowData = jQuery("#list").getRowData(rowId);
            showData = "<table style='border:0px;width: 280px;'>";
            if ($("#showGridpopup").prop('checked')) {
                showData = showData + '<tr><td class="popup-div-tble-header"><b>Bookmarks</b></td><td class="popup-div-tble ">' + RowData['BookmarksIDX'] + '</td></tr>';
                showData = showData + '<tr><td class="popup-div-tble-header"><b>Comments</b></td><td class="popup-div-tble ">' + RowData['CallCommentIDX'] + '</td></tr>';
                showData = showData + '<tr><td class="popup-div-tble-header"><b>ANI Name</b></td><td class="popup-div-tble ">' + RowData['ANI_NAMEIDX'] + '</td></tr>';
                showData = showData + '<tr><td class="popup-div-tble-header"><b>ANI Phone</b></td><td class="popup-div-tble ">' + RowData['ANI_PHIDX'] + '</td></tr>';
                showData = showData + '<tr><td class="popup-div-tble-header"><b>ANI Detail</b></td><td class="popup-div-tble ">' + RowData['ANI_DETAILSIDX'] + '</td></tr>';
                showData = showData + '<tr><td class="popup-div-tble-header"><b>Delete ?</b></td><td class="popup-div-tble ">' + RowData['RetainValueIDX'] + '</td></tr>';
            }
            if ($("#showGridPopupHidden").prop('checked')) {
                showData = showData + '<tr><td style="#7f9db9" colspan="2" nowrap="nowrap" style="background: #099cd0;"><b>Hidden Fields</b></td></tr>';
                showData = showData + '<tr><td class="popup-div-tble-header"><b>Group Name</b></td><td class="popup-div-tble ">' + RowData['GroupNameIDX'] + '</td></tr>';
                showData = showData + '<tr><td class="popup-div-tble-header"><b>Ext Name</b></td><td class="popup-div-tble ">' + RowData['ExtNameIDX'] + '</td></tr>';
                showData = showData + '<tr><td class="popup-div-tble-header"><b>AudioFileName</b></td><td class="popup-div-tble ">' + RowData['AudioFileNameIDX'] + '</td></tr>';
            }
            showData = showData + '</table>';

            var divWidth = $("#pop-up-grid").width();
            var divheight = $("#pop-up-grid").height();
            horizontalPos = $(window).width() - divWidth - 20;
            verticalPos = e.pageY + moveDown;
            if ($(window).height() < (e.pageY + divheight + 200))
                verticalPos = e.pageY - divheight;

            $("#pop-up-grid").html(showData);
            $("div#pop-up-grid").css('top', verticalPos).css('left', horizontalPos);
            $('div#pop-up-grid').show();
        }
    });
    $('#list').mouseout(function(e) {
        $('div#pop-up-grid').hide();
    });
}

function exportExcel() {
    var mya = new Array();
    mya = $("#list").getDataIDs(); // Get All IDs
    var data = $("#list").getRowData(mya[0]); // Get First row to get the labels
    var colNames = new Array();
    var ii = 0;
    for (var i in data) {
        colNames[ii++] = i;
    } // capture col names
    var html = "";
    for (i = 0; i < mya.length; i++) {
        data = $("#list").getRowData(mya[i]); // get each row
        for (j = 0; j < colNames.length; j++) {
            html = html + data[colNames[j]] + "\t"; // output each column as tab delimited
        }
        html = html + "\n"; // output each row with end of line

    }
    html = html + "\n"; // end of line at the end
    document.forms[0].csvBuffer.value = html;
    document.forms[0].method = 'POST';
    document.forms[0].action = 'csvExport.php'; // send it to server which will open this contents in excel file
    document.forms[0].target = '_blank';
    document.forms[0].submit();
}

function IsAlreadyAdded(idx) {
    var ASPlayer = document.getElementById("ASPlayer");
    try {
        if (ASPlayer.IsExist(idx) == 1) return true;
        else return false;
    } catch(e) {
        return false;
    }
}

function DBCLICKeVENT(id) {
    var ASPlayer = document.getElementById("ASPlayer");
    try {
        ASPlayer.ChangePlay(id);
        if (l_LoggedID != id) {
            l_LoggedID = id;
            SaveCallOperationLog(id, 1);
        }
    } catch(e) {
    }
}

function GetDurationMili(Duration) {
    return Duration.substring(0, 2) + Duration.substring(3, 5) + Duration.substring(6, 8);
}


function RefreshGrid() {
    jQuery("#list").setGridParam({ page: 1 });
    jQuery("#list").trigger("reloadGrid");
}

function OnTreeClick(evt) {
    var src = window.event != window.undefined ? window.event.srcElement : evt.target;
    var isChkBoxClick = (src.tagName.toLowerCase() == "input" && src.type == "checkbox");
    if (isChkBoxClick) {
        var parentTable = GetParentByTagName("table", src);
        var nxtSibling = parentTable.nextSibling;
        if (nxtSibling && nxtSibling.nodeType == 1)//check if nxt sibling is not null & is an element node 
        {
            if (nxtSibling.tagName.toLowerCase() == "div") //if node has children 
            {
                CheckUncheckChildren(parentTable.nextSibling, src.checked);
            }
        }
        CheckUncheckParents(src, src.checked);
    }
}

function CheckUncheckChildren(childContainer, check) {
    var childChkBoxes = childContainer.getElementsByTagName("input");
    var childChkBoxCount = childChkBoxes.length;
    for (var i = 0; i < childChkBoxCount; i++) {
        childChkBoxes[i].checked = check;
    }
}


function CheckUncheckParents(srcChild, check) {
    var parentDiv = GetParentByTagName("div", srcChild);
    var parentNodeTable = parentDiv.previousSibling;


    if (parentNodeTable) {
        var checkUncheckSwitch;
        if (check) //checkbox checked 
        {
            var isAllSiblingsChecked = AreAllSiblingsChecked(srcChild);
            if (isAllSiblingsChecked)
                checkUncheckSwitch = true;
            else
                return; //do not need to check parent if any child is not checked 
        } else //checkbox unchecked 
        {
            checkUncheckSwitch = false;
        }


        var inpElemsInParentTable = parentNodeTable.getElementsByTagName("input");
        if (inpElemsInParentTable.length > 0) {
            var parentNodeChkBox = inpElemsInParentTable[0];
            parentNodeChkBox.checked = checkUncheckSwitch;
            //do the same recursively 
            CheckUncheckParents(parentNodeChkBox, checkUncheckSwitch);
        }
    }
}


function AreAllSiblingsChecked(chkBox) {
    var parentDiv = GetParentByTagName("div", chkBox);
    var childCount = parentDiv.childNodes.length;
    for (var i = 0; i < childCount; i++) {
        if (parentDiv.childNodes[i].nodeType == 1) //check if the child node is an element node 
        {
            if (parentDiv.childNodes[i].tagName.toLowerCase() == "table") {
                var prevChkBox = parentDiv.childNodes[i].getElementsByTagName("input")[0];
                //if any of sibling nodes are not checked, return false 
                if (!prevChkBox.checked) {
                    return false;
                }
            }
        }
    }
    return true;
}


//utility function to get the container of an element by tagname 

function GetParentByTagName(parentTagName, childElementObj) {
    var parent = childElementObj.parentNode;
    while (parent.tagName.toLowerCase() != parentTagName.toLowerCase()) {
        parent = parent.parentNode;
    }
    return parent;
}

function Monirtoring() {
    $.ajax(
        {
            type: "POST",
            url: "PageFunctions.aspx/GetMonitoringSignin",
            contentType: "application/json; charset=utf-8",
            data: "{}",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            dataType: "json",
            success: MoniteringSignin,
            error: MoniteringSigninFailed
        }
    );
}

function GetParentByTagName123(parentTagName, childElementObj) {
    var parent = childElementObj.parentNode;
    while (parent.tagName.toLowerCase() != parentTagName.toLowerCase()) {
        parent = parent.parentNode;
    }
    return parent;
}

function MoniteringSigninFailed(result) {
    $("#blocker").show();
    alert(result.status + ' ' + result.statusText);
    $("#blocker").hide();
}

function AddMonitoringChannels(results) {
    //$("#blocker").show();
    var LiveMonitoringCTRL = document.getElementById("LiveMonitoringCTRL");
    try {
        var obj = $.parseJSON(results.d);
        LiveMonitoringCTRL.FreeAllChannels();
        LiveMonitoringCTRL.Disconnect();
        $.each(obj, function() {
            var nUserNum = this["nUserNum"];
            var strUserID = this["strUserID"];
            var strExt = this["strExt"];
            var nLoggerID = this["nLoggerID"];
            var strLoggerIP = this["strLoggerIP"];
            var nLoggerPort = this["nLoggerPort"];
            var strPassword = this["strPassword"];
            var nSOD = this["nSOD"];
            var nPOD = this["nPOD"];
            var nLOD = this["nLOD"];
            var nEOD = this["nEOD"];
            var nUserGroupNum = this["nUserGroupNum"];
            var pstrUserName = this["pstrUserName"];
            var strChannelName = this["strChannelName"];
            var strUserEmail = this["strUserEmail"];
            LiveMonitoringCTRL.AddChannelInfo(nUserNum, strUserID, strExt, nLoggerID, strLoggerIP, nLoggerPort, strPassword, strExt, nSOD, nPOD, nLOD, nEOD, nUserGroupNum, pstrUserName, strChannelName, strUserEmail)
        });

        LiveMonitoringCTRL.ConnectAllChannels();
    } catch(e) {
    }
    $("#blocker").hide();
}

function AddMonitoringChannelsFailed(result) {
    alert(result.status + ' ' + result.statusText);
}

var Cookies =
{
    // Initialize by splitting the array of Cookies
    init: function() {
        var allCookies = document.cookie.split('; ');
        for (var i = 0; i < allCookies.length; i++) {
            var cookiePair = allCookies[i].split('=');
            this[cookiePair[0]] = cookiePair[1];
        }
    },
    // Create Function: Pass name of cookie, value, and days to expire
    create: function(name, value, days) {
        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
            var expires = "; expires=" + date.toGMTString();
        } else var expires = "";
        document.cookie = name + "=" + value + expires + "; path=/";
        this[name] = value;
    },
    // Erase cookie by name
    erase: function(name) {
        this.create(name, '', -1);
        this[name] = undefined;
    }
};

function readCookie(name) {
var nameEQ = escape(name) + "=";
var ca = document.cookie.split(';');
for(var i=0;i < ca.length;i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1,c.length);
        if (c.indexOf(nameEQ) == 0) return unescape(c.substring(nameEQ.length,c.length));
}
return null;
}
// Save Book Marks into DB

function GetBooksMarks(RowID) {
    var RowData = jQuery("#list").getRowData(RowID);
    CallIDIDX = RowData["CallIDIDX"];
    var params123 = new Object();
    params123.GridPlayIdx = CallIDIDX;
    $.ajax({
        url: "PageFunctions.aspx/GetBooksMarkBYCallID",
        data: JSON.stringify(params123),  // For empty input data use "{}",
        dataType: "json",
        type: "POST",
        serializeGridData: function(postData) {
            return JSON.stringify(postData);
        },
        contentType: "application/json; charset=utf-8",
        success: function(result) {
            var ASPlayer = document.getElementById("ASPlayer");
            try {

                ASPlayer.SendXMLString(result.d);
            } catch(e) {
                alert("load xml")
            }
        }
    });
}

function SaveAsloggerBookMarksMonitor(GridPlayIdx, lPlayPos, bstrBookMark, lSaveType) {
    var params = new Object();
    params.GridPlayIdx = GridPlayIdx;
    params.lPlayPos = lPlayPos;
    params.bstrBookMark = bstrBookMark;
    params.lSaveType = lSaveType;
    if (lSaveType == 0) {
        $.ajax({
            url: "PageFunctions.aspx/SaveBooksMarks",
            data: JSON.stringify(params),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: function(result) {
                //alert("Bookmark added successfully.");
            },
            error: BookMarkFailure
        });
    }
}

function SaveRating(CallID, value) {
    var params = new Object();
    params.CallIDIDX = CallID;
    params.CallRating = '' + value + '';
    $.ajax({
        url: "PageFunctions.aspx/UpdateCallRating",
        data: JSON.stringify(params),  // For empty input data use "{}",
        dataType: "json",
        type: "POST",
        serializeGridData: function(postData) {
            return JSON.stringify(postData);
        },
        contentType: "application/json; charset=utf-8",
        success: function(result) {
            var callRating;
            if (value == 0)
                callRating = "<img src=\"./Images/no.gif\" />";
            else if (value == 1)
                callRating = "<img src=\"./Images/1star.gif\" />";
            else if (value == 2)
                callRating = "<img src=\"./Images/2star.gif\" />";
            else if (value == 3)
                callRating = "<img src=\"./Images/3star.gif\" />";
            else if (value == 4)
                callRating = "<img src=\"./Images/4star.gif\" />";
            else if (value == 5)
                callRating = "<img src=\"./Images/5star.gif\" />";

            jQuery("#list").setCell(GloabParams.rowid.toString(), getColumnSrcIndexByName($("#list"), 'Rating'), callRating, '', '');
            //alert("Call Rating Added Successfully.");
        },
        error: function(result) {
            alert("Error Occurred.");
        }
    });
}

function SaveRatingLiveCall(CallID, value) {
    var params = new Object();
    params.CallIDIDX = CallID;
    params.CallRating = '' + value + '';
    $.ajax({
        url: "PageFunctions.aspx/UpdateCallRating",
        data: JSON.stringify(params),  // For empty input data use "{}",
        dataType: "json",
        type: "POST",
        serializeGridData: function(postData) {
            return JSON.stringify(postData);
        },
        contentType: "application/json; charset=utf-8",
        success: function(result) {
            //alert("Call Rating Added Successfully.");
        },
        error: function(result) {
            alert("Error Occurred.");
        }
    });
}

function SaveCallStatus(CallID, value) {
    var params = new Object();
    params.CallIDIDX = CallID;
    params.iRow = '0';
    params.iCol = '0';
    params.Flag = '' + value + '';
    $.ajax({
        url: "PageFunctions.aspx/UpdateCallStatus",
        data: JSON.stringify(params),  // For empty input data use "{}",
        dataType: "json",
        type: "POST",
        serializeGridData: function(postData) {
            return JSON.stringify(postData);
        },
        contentType: "application/json; charset=utf-8",
        success: function(result) {
            /*if (value == 2)
                alert("Call Marked Important.");
            else
                alert("Call Marked Emergency.");*/
        },
        error: function(result) {
            alert("Error Occurred.");
        }
    });
}

function AddTagComments(CallID, text, type) {
    var params = new Object();
    params.Comments = text;
    params.CallID = CallID;
    if (type == 1) {
        $.ajax({
            url: "PageFunctions.aspx/ManageComments",
            data: JSON.stringify(params),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: function(result) {
                //alert("Comments Added successfully.");
            },
            error: function(result) {
                alert("Error Occurred.");
            }
        });
        return;
    }
    $.ajax({
        url: "PageFunctions.aspx/AddTag",
        data: JSON.stringify(params),  // For empty input data use "{}",
        dataType: "json",
        type: "POST",
        serializeGridData: function(postData) {
            return JSON.stringify(postData);
        },
        contentType: "application/json; charset=utf-8",
        success: function(result) {
            //alert("Tag added successfully.");
        },
        error: function(result) {
            //alert("Error Occurred.");
        }
    });
}

function SaveAsloggerBookMarks(GridPlayIdx, lPlayPos, bstrBookMark, lSaveType) {
    var params = new Object();
    params.GridPlayIdx = GridPlayIdx;
    params.lPlayPos = lPlayPos;
    params.bstrBookMark = bstrBookMark;
    params.lSaveType = lSaveType;
    if (lSaveType == 0) {
        $.ajax(
            {
                url: "PageFunctions.aspx/SaveBooksMarks",
                data: JSON.stringify(params),  // For empty input data use "{}",
                dataType: "json",
                type: "POST",
                serializeGridData: function(postData) {
                    return JSON.stringify(postData);
                },
                contentType: "application/json; charset=utf-8",
                success: function(result) {
                    $.ajax({
                        url: "PageFunctions.aspx/GetBooksMarks",
                        data: JSON.stringify(params),  // For empty input data use "{}",
                        dataType: "json",
                        type: "POST",
                        serializeGridData: function(postData) {
                            return JSON.stringify(postData);
                        },
                        contentType: "application/json; charset=utf-8",
                        success: function(result) {
                            var ASPlayer = document.getElementById("ASPlayer");
                            try {

                                ASPlayer.SendXMLString(result.d);
                            } catch(e) {
                                alert("load xml");
                            }

                        },
                        error: BookMarkFailure
                    });
                },
                error: BookMarkFailure
            });
    } else if (lSaveType == 1) {
        $.ajax({
            url: "PageFunctions.aspx/UpdateBookMarks",
            data: JSON.stringify(params),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: BookMarkSuccess,
            error: BookMarkFailure
        });
    }
}

function BookMarkSuccess(result) {

}

function BookMarkFailure(result) {
    alert(result.status + ' ' + result.statusText);
}

function SetGridPopupValue() {
    if ($("#showGridpopup").prop('checked'))
        Cookies.create("showGridpopup", 1, 65);
    else
        Cookies.erase("showGridpopup");

    if ($("#showGridPopupHidden").prop('checked'))
        Cookies.create("showGridPopupHidden", 1, 65);
    else
        Cookies.erase("showGridPopupHidden");
}

function GetOperationTime() {
    var now = new Date();
    var outStr = now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds();
    return outStr;
}

function SaveCallOperationLog(gridPlayIdx, Operation) {
    var RowData = $("#list").getRowData(gridPlayIdx);
    var stringData = "";
    switch (Operation) {
        case 1:
            stringData = " [User Action: Call Played] ";
            break;
        case 10:
            stringData = " [User Action: Call Deleted] ";
            break;
        case 5:
            stringData = " [User Action: Call Saved] ";
            break;
    default:
    }
    stringData = stringData + " [Channel: " + RowData['ExtIDX'] + "]" + " [Call Time: " + RowData['CallTimeIDX'] +"]";
    var params = new Object();
    params.stringData = stringData;
    $.ajax({
            url: "PageFunctions.aspx/SaveCallLog",
            data: JSON.stringify(params),  // For empty input data use "{}",
            dataType: "json",
            type: "POST",
            serializeGridData: function(postData) {
                return JSON.stringify(postData);
            },
            contentType: "application/json; charset=utf-8",
            success: BookMarkSuccess,
            error: BookMarkFailure
        });
}